/*
 * this is a test program using pthreads and crashing to see what happens...
 *
 * Mark Gross 1/21/2002
 */


#include <stdio.h>
#include <pthread.h>
#include <unistd.h>


int GlobalBuffer[100];
pthread_mutex_t myMutex;
int runFlag, crashFlag;


void * UIThread(void * junk)
{
	int io_temp;
	
	while (runFlag)
	{
		pthread_mutex_lock(&myMutex);
		scanf("%d", &io_temp);
		if(io_temp == 1)
			crashFlag = 1;
		if(io_temp == 2)
			runFlag = 0;
		pthread_mutex_unlock(&myMutex);
	}
	
	return 0;
}



void * CPUThread(void *junk )
{	
	int i;
	
	while (runFlag)
	{
		pthread_mutex_lock(&myMutex);
		if( crashFlag == 1)
		{
			printf("attempting to step on memory...\n");
			for( i = 1; i<10000000; i++)
			{
//				GlobalBuffer[-i] = 0xdeadf00d;
				GlobalBuffer[i] = GlobalBuffer[-i];
				printf("attempting to step on memory...0x%x\n", (unsigned int) &GlobalBuffer[-i]);
			}
		}

		pthread_mutex_unlock(&myMutex);
	}
	
	return 0;
}

int main(void)
{
	pthread_t ui, cpu;
	int retVal, i, temp;

	for( i = 0; i<100; i++)
		GlobalBuffer[i] = 0xffffffff;
		
	runFlag = 1;
	crashFlag = 0;

	printf("starting multi threaded application..... 1 to crash 2 to exit\n");

	retVal = pthread_mutex_init(&myMutex, NULL);
	if(retVal)
		printf("pthread_mutex_init failed error value = %d\n", retVal);

	retVal = pthread_create( &ui, NULL, UIThread, NULL);
	if(retVal)
		printf("pthread_create UI errored = %d\n", retVal);

	retVal = pthread_create( &cpu, NULL, CPUThread, NULL);
	if(retVal)
		printf("pthread_create CPU errored = %d\n", retVal);

	while(runFlag)
	{
		sleep(1);
	}
	printf(" falling out of main while loop going to div zero\n");
	temp= 1/runFlag;  // force a div zero

	return 0;
}

